---
title: Report
slug: Web/API/Report
tags:
  - API
  - Experimental
  - Interface
  - Reference
  - Report
  - Reporting API
---
<div>{{seecompattable}}{{APIRef("Reporting API")}}</div>

<p class="summary">The <code>Report</code> interface of the <a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a> represents a single report.</p>

<p class="summary">Reports can be accessed in a number of ways:</p>

<ul>
 <li class="summary">Via the {{domxref("ReportingObserver.takeRecords()")}} method — this returns all reports in an observer's report queue, and then empties the queue.</li>
 <li class="summary">Via the <code>reports</code> parameter of the callback function passed into the <code><a href="/en-US/docs/Web/API/ReportingObserver/ReportingObserver">ReportingObserver()</a></code> constructor upon creation of a new observer instance. This contains the list of reports currently contained in the observer's report queue.</li>
 <li class="summary">By sending requests to the endpoints defined via the {{httpheader("Report-To")}} HTTP header.</li>
</ul>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("Report.body")}} {{readonlyinline}}</dt>
 <dd>The body of the report, which is a <code>ReportBody</code> object containing the detailed report information.</dd>
 <dt>{{domxref("Report.type")}} {{readonlyinline}}</dt>
 <dd>The type of report generated, e.g. <code>deprecation</code> or <code>intervention</code>.</dd>
 <dt>{{domxref("Report.url")}} {{readonlyinline}}</dt>
 <dd>The URL of the document that generated the report.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>This interface has no methods defined on it.</em></p>

<h2 id="Events">Events</h2>

<p><em>This interface has no events that fire on it.</em></p>

<h2 id="Examples">Examples</h2>

<p>In our <a href="https://mdn.github.io/dom-examples/reporting-api/deprecation_report.html">deprecation_report.html</a> example, we create a simple reporting observer to observe usage of deprecated features on our web page:</p>

<pre class="brush: js">let options = {
  types: ['deprecation'],
  buffered: true
}

let observer = new ReportingObserver(function(reports, observer) {
  reportBtn.onclick = () =&gt; displayReports(reports);
}, options);</pre>

<p>We then tell it to start observing reports using {{domxref("ReportingObserver.observe()")}}; this tells the observer to start collecting reports in its report queue, and runs the callback function specified inside the constructor:</p>

<pre class="brush: js">observer.observe();</pre>

<p>Because of the event handler we set up inside the <code>ReportingObserver()</code> constructor, we can now click the button to display the report details.</p>

<p><img alt="image of a jolly bearded man with various stats displayed below it about a deprecated feature" src="https://mdn.mozillademos.org/files/16561/reporting_api_example.png" style="border-style: solid; border-width: 1px; display: block; height: 476px; margin: 0px auto; width: 902px;"></p>

<p>The report details are displayed via the <code>displayReports()</code> fuction, which takes the observer callback's <code>reports</code> parameter as its parameter:</p>

<pre class="brush: js">function displayReports(reports) {
  const outputElem = document.querySelector('.output');
  const list = document.createElement('ul');
  outputElem.appendChild(list);

  for(let i = 0; i &lt; reports.length; i++) {
    let listItem = document.createElement('li');
    let textNode = document.createTextNode('Report ' + (i + 1) + ', type: ' + reports[i].type);
    listItem.appendChild(textNode);
    let innerList = document.createElement('ul');
    listItem.appendChild(innerList);
    list.appendChild(listItem);

    for (let key in reports[i].body) {
      let innerListItem = document.createElement('li');
      let keyValue = reports[i].body[key];
      innerListItem.textContent = key + ': ' + keyValue;
      innerList.appendChild(innerListItem);
    }
  }
}</pre>

<p>The <code>reports</code> parameter contains an array of all the reports in the observer's report queue. We loop over each report using a basic <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a></code> loop, then iterate over each entry of in the report's body using a <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...in">for...in</a></code> structure, displaying each key/value pair inside a list item.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Reporting API","#dom-report","Report")}}</td>
   <td>{{Spec2("Reporting API")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Report")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a></li>
</ul>
